/**
 * Copyright (c) 2010-2018, Zoltan Ujhelyi, Istvan Rath, Daniel Varro, IncQuery Labs Ltd.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 *  * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.patternlanguage.emf.vql.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra.query.patternlanguage.emf.vql.PackageImport;
import org.eclipse.viatra.query.patternlanguage.emf.vql.PatternImport;
import org.eclipse.viatra.query.patternlanguage.emf.vql.PatternLanguagePackage;
import org.eclipse.viatra.query.patternlanguage.emf.vql.VQLImportSection;

import org.eclipse.xtext.xtype.impl.XImportSectionImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>VQL Import Section</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.VQLImportSectionImpl#getPackageImport <em>Package Import</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.VQLImportSectionImpl#getPatternImport <em>Pattern Import</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VQLImportSectionImpl extends XImportSectionImpl implements VQLImportSection
{
	/**
	 * The cached value of the '{@link #getPackageImport() <em>Package Import</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPackageImport()
	 * @generated
	 * @ordered
	 */
	protected EList<PackageImport> packageImport;

	/**
	 * The cached value of the '{@link #getPatternImport() <em>Pattern Import</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPatternImport()
	 * @generated
	 * @ordered
	 */
	protected EList<PatternImport> patternImport;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VQLImportSectionImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return PatternLanguagePackage.Literals.VQL_IMPORT_SECTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PackageImport> getPackageImport()
	{
		if (packageImport == null)
		{
			packageImport = new EObjectContainmentEList<PackageImport>(PackageImport.class, this, PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT);
		}
		return packageImport;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PatternImport> getPatternImport()
	{
		if (patternImport == null)
		{
			patternImport = new EObjectContainmentEList<PatternImport>(PatternImport.class, this, PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT);
		}
		return patternImport;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{
		return org.eclipse.viatra.query.patternlanguage.emf.util.ASTStringProvider.INSTANCE.doSwitch(this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT:
				return ((InternalEList<?>)getPackageImport()).basicRemove(otherEnd, msgs);
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT:
				return ((InternalEList<?>)getPatternImport()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT:
				return getPackageImport();
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT:
				return getPatternImport();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT:
				getPackageImport().clear();
				getPackageImport().addAll((Collection<? extends PackageImport>)newValue);
				return;
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT:
				getPatternImport().clear();
				getPatternImport().addAll((Collection<? extends PatternImport>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT:
				getPackageImport().clear();
				return;
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT:
				getPatternImport().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PACKAGE_IMPORT:
				return packageImport != null && !packageImport.isEmpty();
			case PatternLanguagePackage.VQL_IMPORT_SECTION__PATTERN_IMPORT:
				return patternImport != null && !patternImport.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //VQLImportSectionImpl
